#-------------------------------------------------------------.
# カレント形状でのキーフレーム情報を保持し、ファイルに保存.
# @param[in]  f_location    カレントパス (string).
# @param[in]  pose_name     記録するポーズ名.
# @param[in]  used_humanIK  HumanIKのボーンとして認識するか (true/false).
#-------------------------------------------------------------.
import urllib
import os
import os.path

SAVE_FILE_NAME = 'pose_data.txt'

# --------------------------------------------------------------.
# 指定のボーンに割り当てられているカレントのオフセットと回転を.
# ボーン名をキーとしてファイルに記録.
# --------------------------------------------------------------.
def writeBoneOffsetRotation (f, bone_shape):
	
	if bone_shape.has_motion == False:
		return

	# ボーンかボールジョイントの場合.
	if bone_shape.type == 2 and (bone_shape.part_type == 10 or bone_shape.part_type == 16):
		jointOffset   = bone_shape.bone_joint.offset
		jointRotation = bone_shape.bone_joint.rotation

		wStr = '[' + bone_shape.name + '] ' + str(jointOffset[0]) + ',' + str(jointOffset[1]) + ',' + str(jointOffset[2]) + '  ,' + str(jointRotation[0]) + ',' + str(jointRotation[1]) + ',' + str(jointRotation[2]) + ',' + str(jointRotation[3])
		
		f.writelines(wStr)
		f.writelines('\n')

# --------------------------------------------------------------.
# ボーンをたどり、ファイルにオフセットと回転情報を保存していく.
# --------------------------------------------------------------.
def writeBonesData (f, bone_shape):
	writeBoneOffsetRotation(f, bone_shape)

	if bone_shape.has_son:
		s = bone_shape.son
		while s.has_bro:
			s = s.bro
			writeBonesData(f, s)

# --------------------------------------------------------------.
shape = xshade.scene().active_shape()

# ファイルを開く.
saveFile = urllib.unquote(f_location) + '/datas/' + SAVE_FILE_NAME
f = open(saveFile, 'a')

wStr = '# ' + pose_name + '\n'
f.writelines(wStr)

# ボーン情報をファイル出力.
writeBonesData(f, shape)

f.writelines('\n')

# ファイルを閉じる.
f.close()

result = ''
